//
//  920MHz LoRa/FSK RF module ES920LR3 
//  receive data display for AVR64DB32
//
//  MaiaR Create 2024/2/23
//

#include "oledHYLib1.h"
#include "LoRa.h"

#define OLED_DC     2   // PA2
#define OLED_CS     3   // PA3
#define OLED_RESET  25  // PF5

// ------ OLEDHY クラスによるインスタンスの生成
OLEDHY dispHY( OLED_DC, OLED_RESET, OLED_CS );


void setup() {
  LoRaInit();
  dispHY.begin();
  dispHY.clearFullPage();
  dispHY.disp_on();
  dispHY.draw_stringHYm("LoRa",    12,1,6);
  dispHY.draw_stringHYm("Display", 12,3,6);
  dispHY.draw_stringHYm("Stand-by",12,5,6);
  analogWrite(5, 10);
  
}

void loop(){
  String str;
  char ss[10];
  char Buf[5];
  if (Serial1.available() > 0) {
    String rxs = Serial1.readString();
    Serial.print(rxs);
    rxs.toCharArray(Buf, 5);
    int16_t rssi = abs(strtol(Buf,NULL,16));
    rxs = rxs.substring(4);

    dispHY.clearFullPage();
    dispHY.disp_on();
    dispHY.fillRect( 0xff, 80, 2, 10, 1 );
    
    dispHY.draw_stringHYm("T:", 0, 0, 6);
    str = rxs.substring( 2, 6 );
    str.toCharArray(ss, 10);
    dispHY.draw_stringHYm(ss, 16, 0, 6);
    dispHY.draw_stringHYm(" 'C ", 46, 0, 6);

    dispHY.draw_stringHYm("H:", 0, 2, 6);
    str = rxs.substring( 8, 12 );
    str.toCharArray(ss, 10);
    dispHY.draw_stringHYm(ss, 16, 2, 6);
    dispHY.draw_stringHYm(" % ", 46, 2, 6);

    dispHY.draw_stringHYm("P:", 0, 4, 6);
    str = rxs.substring( 14, 18 );
    str.toCharArray(ss, 10);
    dispHY.draw_stringHYm(ss, 16, 4, 6);
    dispHY.draw_stringHYm(" hPa ", 46, 4, 6);

    dispHY.draw_stringHYm("R: -", 0, 6, 6);
    dispHY.draw_num_m( rssi,26,6,6);
    dispHY.draw_stringHYm(" dB ", 46, 6, 6);
    
    delay(400);
    dispHY.fillRect( 0x00, 80, 2, 10, 1 );
  }
}
